<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import { getClient } from '~/plugins/contentful.js';
import BySolutionHero from '~/components/solutions/by-solution/by-solution-hero.vue';
import { Carousel, Filters } from '@/components/events/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  name: 'Events',
  components: {
    Carousel,
    BySolutionHero,
    Filters,
  },
  nuxtI18n: false,
  async asyncData() {
    const eventsData = await getClient()
      .getEntries({
        content_type: 'event',
        order: 'fields.date',
        limit: 36,
        'fields.endDate[gte]': new Date().toISOString().split('T')[0],
      })
      .then((query: any) => query.items.map((event: any) => event.fields));

    const eventsPageData = await getClient()
      .getEntries({
        content_type: 'page',
        include: 10,
        'sys.id': '3ooZbNzGphncsmMpi73gWV',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;

        const videosID = '2dLePn1XdVa7TqbJm7SaCz';
        const heroID = '1zOZGEQ6NxgYpdvuiqwTch';

        const videoData = entryFields.pageContent.find(
          (obj) => obj.sys.id === videosID,
        ).fields;
        const heroData = entryFields.pageContent.find(
          (obj) => obj.sys.id === heroID,
        ).fields;

        // Iterate through each video in the carousel
        const mappedVideos = videoData.videos.map((video: any) => ({
          title: video.fields?.internalName,
          video_link: video.fields?.url,
          photourl: video.fields?.thumbnail?.fields?.image?.fields?.file.url,
          carousel_identifier: ['Event Videos'],
        }));

        const hero = { ...heroData, title: heroData.header };
        const seoMetadata = entryFields.seoMetadata[0].fields;

        return {
          hero,
          seoMetadata,
          videoCarousel: {
            header: 'Event Videos',
            videos: mappedVideos,
          },
        };
      })
      .catch(console.error);

    return {
      eventsData,
      eventsPageData,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).eventsPageData.seoMetadata,
      this.$route.path,
    );
  },
});
</script>

<template>
  <SlpContainer>
    <BySolutionHero :data="eventsPageData.hero" />
    <Carousel
      v-if="eventsPageData.videoCarousel"
      :data="eventsPageData.videoCarousel"
    />
    <SlpTypography tag="h2" variant="heading2-bold"
      >Upcoming events
    </SlpTypography>
    <Filters v-if="eventsData" :data="eventsData" />
  </SlpContainer>
</template>
